unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Process;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;
  AProcess: TProcess;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  CmdLine, Datafile: string;
begin
  {$IFDEF WINDOWS}
  CmdLine := 'counter.exe';
  {$ELSE}
  CmdLine := '/home/me/counter/counter';
  {$ENDIF}
  Datafile := 'lines.txt';
  AProcess := TProcess.Create(nil);
  try
    AProcess.Executable := CmdLine;
    AProcess.Parameters.Add(Datafile);
    AProcess.Options := AProcess.Options + [poWaitOnExit];
    AProcess.Execute;
    if AProcess.ExitCode <> 0 then
      ShowMessageFmt('Error: %s reports error code %d', [CmdLine, AProcess.ExitCode]);
  finally
    AProcess.Free;
  end;
end;

end.

